'Setup Port adr
'------------------------------------------------
'Printer Port 1 is at 378 Hex or 888 Decimal
'Printer Port 2 is at 278 Hex or 632 Decimal
'Printer Port 3 is at 3bc Hex or 956 Decimal
'------------------------------------------------
'You can use the calculator supplied with Windows
'to figure this stuff out.  Click on View and put
'it in Scientific mode!  Click Hex mode.
'Enter your hex number, then click Decimal.
'------------------------------------------------
  DataPort = 888              '378 hex printer port #1
  ControlPort = DataPort + 2  'Control port is ALWAYS base adr +2 !   


'Setup CD4515 Control Data
'NOTE: Control Bits 1,2 & 8 are inverted!
'Only bits 1 and 2 are used here.
'--------------------------------------------------------------------
'                  Data Data
'  Name = Data     Sent Out               Function
'----------------- ---- ---- ----------------------------------------
  DataLatch = 11  '1011 0000 /LE Pin  1 CD4515 = Low  Latch Data
  DataAccept = 10 '1010 0001 /LE Pin  1 CD4515 = High Accept New Data
  StrobeOn = 11   '1011 0000 /En Pin 23 CD4515 = Low  Enable Output
  StrobeOff = 9   '1001 0010 /En Pin 23 CD4515 = High Disable Output

'Setup Strobe Adr
'All 15 are set up.  Only 5 (0-4) are used here.
'-----------------------------------------------
  DIM Strobe(15)
  FOR ctr = 0 TO 15
    Strobe(ctr) = ctr
  NEXT ctr

'Intialize
'---------
  OUT DataPort, 0
  OUT ControlPort, DataAccept AND StrobeOff
                                     
'---------------------------------------------------------------
'Program Test Frequency of 123.456 789 0 Mhz
'---------------------------------------------------------------
'Programming is in Hex / Binary active LOW!
'         Hex =  80 + 40 + 20 + 10 + 8 + 4 + 2 + 1
'     Decimal = 128 + 64 + 32 + 16 + 8 + 4 + 2 + 1
'---------------------------------------------------------------
'When programming 3 and 6 your output line would look like this:
' OUT DataPort, 128 + 64 + 0 + 0 + 8 + 0 + 0 + 1 (decimal)
'                         20h+ 10h= 30           (hex)
'                                     4h + 2h= 6 (hex)
'---------------------------------------------------------------

Parallel:
'--------------------------------
'-----> 100 / 10 Mhz Digits -----
'--------------------------------
  OUT DataPort, Strobe(0)                   '<Controls which pin is active on the CD4515
  OUT ControlPort, DataAccept AND StrobeOff 'Enters data in CD4515
  OUT ControlPort, DataLatch AND StrobeOff  'Latches data in CD4515
'Remember to AND both DataLatch and StrobeOff or you will affect the other signal line!
'-------------------------------------------------
'PTS-160 has NO 100 Mhz digit.       10 Mhz digit goes to 15 (150 Mhz)
'               Not Used On PTS160   8+4=12x10 Mhz
'               ------------------   -------------
' OUT DataPort, 128 + 64 + 32 + 16 + 0 + 0 + 2 + 1
'-------------------------------------------------
' Next line is for PTS-200 and PTS 500!
'               10 x 10 = 100 Mhz   2x10= +20 Mhz
'               -----------------   -------------
  OUT DataPort, 128 + 64 + 32 + 0 + 8 + 4 + 0 + 1
'------------------------------------------------
  OUT ControlPort, DataLatch AND StrobeOn    '<Enable CD4515
  OUT ControlPort, DataLatch AND StrobeOff   '<Disable CD4515

'-----------------------------------
'-----> 1 Mhz / 100 Khz Digits -----
'-----------------------------------
  OUT DataPort, Strobe(1)
  OUT ControlPort, DataAccept AND StrobeOff
  OUT ControlPort, DataLatch AND StrobeOff
'               20 + 10 = +3 Mhz   4 = +400 Khz
'               ----------------   -------------
  OUT DataPort, 128 + 64 + 0 + 0 + 8 + 0 + 2 + 1
  OUT ControlPort, DataLatch AND StrobeOn
  OUT ControlPort, DataLatch AND StrobeOff

'------------------------------
'-----> 10 / 1 Khz Digits -----
'------------------------------
  OUT DataPort, Strobe(2)
  OUT ControlPort, DataAccept AND StrobeOff
  OUT ControlPort, DataLatch AND StrobeOff
'               40 + 10= +50 Khz   4 + 2= +6 Khz  
'               ----------------   -------------
  OUT DataPort, 128 + 0 + 32 + 0 + 8 + 0 + 0 + 1
  OUT ControlPort, DataLatch AND StrobeOn
  OUT ControlPort, DataLatch AND StrobeOff

'-------------------------------
'-----> 100 / 10 Hz Digits -----
'-------------------------------
  OUT DataPort, Strobe(3)
  OUT ControlPort, DataAccept AND StrobeOff
  OUT ControlPort, DataLatch AND StrobeOff
'             40+20+10= +700 Hz   8 = +80 Hz
'               ---------------   -------------
  OUT DataPort, 128 + 0 + 0 + 0 + 0 + 4 + 2 + 1
  OUT ControlPort, DataLatch AND StrobeOn
  OUT ControlPort, DataLatch AND StrobeOff

'------------------------------
'-----> 1 / 0.1 Hz Digits -----
'------------------------------
  OUT DataPort, Strobe(4)
  OUT ControlPort, DataAccept AND StrobeOff
  OUT ControlPort, DataLatch AND StrobeOff
'               80 + 10 = 9 Hz    0.1 Hz Not used on PTS-160
'               ---------------   -------------
  OUT DataPort, 0 + 64 + 32 + 0 + 8 + 4 + 2 + 1
  OUT ControlPort, DataLatch AND StrobeOn
  OUT ControlPort, DataLatch AND StrobeOff

'-----------------------------------------------------
'----- Loop with delay so pulses can be seen on scope!
'-----------------------------------------------------
GOSUB Delay3: GOTO Parallel

Delay3:
  FOR ctr = 1 TO 2
   i$ = INKEY$
   IF i$ = " " GOTO Shutdown
  NEXT ctr
RETURN

Shutdown:
END