'Setup Port adr
'--------------
  DataPort = 888
  ControlPort = DataPort + 2

'Setup CD4515 Control Data
'NOTE: Control Bits 1,2 & 8 are inverted!
'Only Bits 1 and 2 are being used here.
'                  Data Data
'                  Sent Out
'----------------- ---- ---- ----------------------------------------
  DataLatch = 11  '1011 0000 /LE Pin  1 CD4515 = Low  Latch Data
  DataAccept = 10 '1010 0001 /LE Pin  1 CD4515 = High Accept New Data
  StrobeOn = 11   '1011 0000 /En Pin 23 CD4515 = Low  Enable Output
  StrobeOff = 9   '1001 0010 /En Pin 23 CD4515 = High Disable Output

'Setup Strobe Adr
'----------------
  DIM Strobe(15)
  FOR ctr = 0 TO 15
    Strobe(ctr) = ctr
  NEXT ctr

'Intialize
'---------
  OUT DataPort, 0
  OUT ControlPort, DataAccept AND StrobeOff
                                     
'-------------------------------------------
'Program Test Frequency of 123.456 789 0 Mhz
'-------------------------------------------
Parallel:
'-----> 100 / 10 Mhz
  OUT DataPort, Strobe(0)
  OUT ControlPort, DataAccept AND StrobeOff
  OUT ControlPort, DataLatch AND StrobeOff
'10 Mhz digit goes to 15 (150 Mhz) on PTS-160 !
'             NotUsedOnPTS-160     8+4=12x10 Mhz
'             ------------------   -------------
  OUT DataPort, 128 + 64 + 32 + 16 + 0 + 0 + 2 + 1
  OUT ControlPort, DataLatch AND StrobeOn
  OUT ControlPort, DataLatch AND StrobeOff
'-----> 1 Mhz / 100 Khz
  OUT DataPort, Strobe(1)
  OUT ControlPort, DataAccept AND StrobeOff
  OUT ControlPort, DataLatch AND StrobeOff
'             20 + 10 = +3 Mhz    4 = +400 Khz
'             ----------------   -------------
  OUT DataPort, 128 + 64 + 0 + 0 + 8 + 0 + 2 + 1
  OUT ControlPort, DataLatch AND StrobeOn
  OUT ControlPort, DataLatch AND StrobeOff
'-----> 10 / 1 Khz
  OUT DataPort, Strobe(2)
  OUT ControlPort, DataAccept AND StrobeOff
  OUT ControlPort, DataLatch AND StrobeOff
'             40 + 10= +50 Khz   4 + 2= +6 Khz      
'             ----------------   -------------
  OUT DataPort, 128 + 0 + 32 + 0 + 8 + 0 + 0 + 1
  OUT ControlPort, DataLatch AND StrobeOn
  OUT ControlPort, DataLatch AND StrobeOff
'-----> 100 / 10 Hz
  OUT DataPort, Strobe(3)
  OUT ControlPort, DataAccept AND StrobeOff
  OUT ControlPort, DataLatch AND StrobeOff
'           40+20+10= +700 Hz   8 = +80 Hz
'           -----------------   -------------
  OUT DataPort, 128 + 0 + 0 + 0 + 0 + 4 + 2 + 1
  OUT ControlPort, DataLatch AND StrobeOn
  OUT ControlPort, DataLatch AND StrobeOff
'-----> 1 / 0.1 Hz
  OUT DataPort, Strobe(4)
  OUT ControlPort, DataAccept AND StrobeOff
  OUT ControlPort, DataLatch AND StrobeOff
'             80 + 10 = 9 Hz    0.1 Hz Not used on PTS-160
'             ---------------   -------------
  OUT DataPort, 0 + 64 + 32 + 0 + 8 + 4 + 2 + 1
  OUT ControlPort, DataLatch AND StrobeOn
  OUT ControlPort, DataLatch AND StrobeOff

'----- Loop with delay so pulses can be seen on scope!
'-----------------------------------------------------
GOSUB Delay3: GOTO Parallel

Delay3:
  FOR ctr = 1 TO 2
   i$ = INKEY$
   IF i$ = " " GOTO Shutdown
  NEXT ctr
RETURN

Shutdown:
END

