'---------------------------------------------------
'Bits 1,2,& 8 are inverted in printer port hardware!
'NOTE: No data lines are inverted.
'---------------------------------------------------
'DB-25                    Program Output Output CD4515
'Pin xx Bit          Data Binary  Binary PIN xx
'------ ---- ------- ---- ------  ------ ------
'Pin 17 Bit1 High ==   3   0011   0001   Pin 22 High
'Pin 16 Bit2 High ==  15   1111   0010   Pin 21 High
'Pin 14 Bit4 High ==   9   1001   0100   Pin  3 High
'Pin  1 Bit8 High ==  10   1010   1000   Pin  2 High
'
'                                 ^DB25 Pin 1
'                                  ^DB25 Pin 14
'                                   ^DB25 Pin 16
'                                    ^DB25 Pin 17
'
'Pin 17 Bit 8 Low === 12   1100   0111   Pin 22 Low
'Pin 16 Bit 4 Low ===  0   0000   1011   Pin 21 Low
'Pin 14 Bit 2 Low ===  6   0110   1101   Pin  3 Low
'Pin  1 Bit 1 Low ===  5   0101   1110   Pin  2 Low
'-----
'All High ===========  4   0100   1111
'All Low  =========== 11   1011   0000
'------
'----- Test Routine -----
'PrinterPort = 888
'StrobePort = PrinterPort + 2
'OUT StrobePort, 11
'END
'------------------------

'-------------------
'Program begins here
'-------------------
CLS
PrinterPort = 888
StrobePort = PrinterPort + 2
DIM Strobe(15)

'---------------------------------------
'Bits 1,2 & 8 are inverted !
'
'A dimensioned array is used to hold this
'data so it can be easily sequenced with
'a FOR NEXT loop if neccessary!
'
'          Dec  Binary Output  CD4514
'Name      Data  Data  Binary  Pin xx Yxx
'----------------------------------------
StrobeOff = 11  '1011  0000    Pin 11 Y0
Strobe(1) = 10  '1010  0001    Pin 10 Y1
Strobe(2) = 9   '1001  0010    Pin  9 Y2
Strobe(3) = 8   '1000  0011    Pin  8 Y3
Strobe(4) = 15  '1111  0100    Pin  7 Y4
Strobe(5) = 14  '1110  0101    Pin  6 Y5
Strobe(6) = 13  '1101  0110    Pin  5 Y6
Strobe(7) = 12  '1100  0111    Pin  4 Y7
Strobe(8) = 3   '0011  1000    Pin 18 Y8
Strobe(9) = 2   '0010  1001    Pin 17 Y9
Strobe(10) = 1  '0001  1010    Pin 20 Y10
Strobe(11) = 0  '0000  1011    Pin 19 Y11
Strobe(12) = 7  '0111  1100    Pin 13 Y12
Strobe(13) = 6  '0110  1101    Pin 14 Y13
Strobe(14) = 4  '0100  1110    Pin 15 Y14
Strobe(15) = 5  '0101  1111    Pin 16 Y15

'Example output routine
parallel:
OUT StrobePort, Strobe(1)
OUT StrobePort, StrobeOff

